
/*=============================================================================
   beest, an HTML viewer.
   Copyright (C) 2000 Zachary Thayer Smith

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   The author is reachable by electronic mail at zeyr@excite.com.
=============================================================================*/

/*----------------------------------------------------------------------
 * Module name:    read.c
 * Author name:    Zach Smith
 * Create date:    1 Oct 2000
 * Last change:    26 Nov 2000
 * Purpose:        Routines for character reading.
 *----------------------------------------------------------------------
 * Changes:
 *--------------------------------------------------------------------*/


#include <stdio.h>

#include "defs.h"
#include "error.h"
#include "main.h"


static int ungot=-1;
static int ungot2=-1;

int my_getchar(FILE* f) {
	int ch;
	CHECK_PARAM_NOT_NULL(f);
	if (ungot>=0) { ch=ungot; ungot=ungot2; ungot2=-1; return ch; }
	ch=fgetc(f);
	if (ch=='\r' || ch=='\n' || ch=='\t') ch=' ';
	return ch;
}

void my_unget(int ch) {
	if (ungot>=0 && ungot2>=0) error_handler ("3rd ungot");
	ungot2=ungot;
	ungot=ch;
}

